package abstractmath

import abstractmath.Real.Companion.R0
import java.lang.ArithmeticException

operator fun <El : Field<El>> El.plus(x: EuclideanVector<El>): ComplexOver<ComplexOver<El>> {
    if (x.list.size > 3) throw ArithmeticException("Has no sense") //FIXME?
    return ComplexOver(ComplexOver(this, x[0, zero()]), ComplexOver(x[1, zero()], x[2, zero()]))
}

operator fun <El :Field<El>> EuclideanVector<El>.plus(x : El) = x + this

operator fun Quaternion.times(x: EVector) = this * (R0 + x)

fun Quaternion.scalar() = this.re.re
fun Quaternion.vector() = EuclideanVector(re.im, im.re, im.im)

