package graphics

import java.awt.*
import javax.swing.JFrame
import javax.swing.JPanel
import javax.swing.WindowConstants

interface GraphicsProvider {
    fun paint(g: Graphics, width : Int, height:Int)
}

private class Canvas(val gp: GraphicsProvider) : JPanel() {
    override fun paint(g: Graphics?) {
        gp.paint(g!!, width, height)
    }
}

class CanvasWindow(val gp: GraphicsProvider, title:String) : JFrame(title) {
    init {
        layout = GridLayout(1, 1)
        add(Canvas(gp))
        defaultCloseOperation = EXIT_ON_CLOSE
        setSize(1920, 1080)
        isVisible = true
    }
}