@file:Suppress("UNUSED_VARIABLE")

package graphics

import abstractmath.*
import abstractmath.Real.Companion.R0
import abstractmath.Real.Companion.R1
import graphics.figures.*

var axis = EVector(R0, R0, R1)

public const val showCarcassOnly = false
public val LIGHT_VECTOR = EVector(-1.R, 1.R, -2.R)

fun main() {
        val figure = Icosahedron()
        val window = CanvasWindow(figure, "Graphics demo")

        ConsoleReader().start()
        println("Waiting...")

        while (true) {
            Thread.sleep(10)
            figure.rotate(0.012, axis)
            window.repaint()
        }
}

