package graphics.figures


import abstractmath.Real.Companion.R0
import java.awt.Color
import kotlin.math.sqrt

val gr = ((1 + sqrt(5.0)) / 2) //Golden ratio or Golden mean

class Cube : Figure() {
    init {
        allCombinations(1.pm, 1.pm, 1.pm)
        verticesOfAllVectors("A A' B B' D D' C C'".split(" "))
        edgesOfLength(2.0, Color.blue)
        facesOfVertices(4, Color.RED)
    }
}

class Cuboctahedron : Figure() {
    init{
        circlePermutations(1.pm, 1.pm, listOf(R0))
        verticesOfAllVectors()
        edgesOfLength(sqrt(2.0), Color.yellow)
        facesOfVertices(3, Color.blue)
        facesOfVertices(4, Color.red)
    }
}

class Icosahedron : Figure() {
    init {
        circlePermutations(listOf(R0), 1.pm, gr.pm)
        verticesOfAllVectors()
        edgesOfLength(2.0, Color.blue)
        facesOfVertices(3, Color.white)
    }
}

